 #!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep  1 07:43:29 2019

@author: evan

This script analyses data generated from the controllable pulse-width TMS 
input/output curve protocol run using Signal (Signal config file in github). 
Steps:
    1. Import and read EMG data from .mat files exported from Signal.
    2. Measure the peak-to-peak MEP amplitude and associate with Signal state.
    3. Correlate Signal state with stim intensity (import stim settings .csv file 
        - manually generated from session notes - ?automate)
    4. Fit sigmoid curves to MEP vs. stim intensity
    5. Generate plots (per-sweep data QC, individual level scatter and curves)

To do:
    1. check for pre-stimulus contraction
    2. outlier removal
    3. labelling time ranges/MEP peaks in plot for visual inspection for data 
        quality control
    4. Group level analysis
"""

import os
import re
import ctms_utils
import pandas as pd
import numpy as np
import seaborn as sns
from matplotlib import pyplot as plt
from scipy.optimize import curve_fit
from biosppy.signals.emg import find_onsets
from itertools import groupby

#%% Setup
#------------------------------------------------------------------------------
wdir = '/home/evan/pilotdata/working/2019_09_21_ctmsio_2ses/bids'
plotdir = os.path.join(wdir,'group_plot')
    
groupalloc = {'003':'ycon', '005':'ycon', '006':'ycon', '007':'ycon', '008':'acon', '009':'pat', '010':'ycon', '011':'ycon'}

# Plot each EMG sweep to check time range + MEP peak to peak measurement
plotEachSweep = False
plotEachBlock = True
plotEachSubject = True

# Set time (seconds) and sample ranges for MEP and pre-contraction 
# (5000 samples per frame)
mep_time = np.array([1.02, 1.06])
precon_time = np.array([0.45, 0.49])

# Set file name formats script will look for for data format and stim settings
datafilepattern = '*ctmsio*.mat'
stim_settings_pattern = '*stim_settings.csv'

# Set file directory structure pattern (/root/subject/session/modality)
wildcardpath = os.path.join(wdir, 'sub*', 'ses*', 'ctms')

patterns_present = ctms_utils.getPathsWithFiles(wildcardpath, [datafilepattern, stim_settings_pattern])

if not os.path.exists(plotdir):
    os.mkdir(os.path.join(plotdir))

alldata = pd.DataFrame()
list_block_summary = []

##%% Iterate subject directories
##------------------------------------------------------------------------------

for datapath in patterns_present:
    
    curvepars = {}
    figs = []
    
    subj = datapath.split(os.path.sep)[-3]
    ses = datapath.split(os.path.sep)[-2]
    
    # Read .csv file containing stim settings
    stimSettings = ctms_utils.readStimSettings(
            os.path.join(datapath, f'{subj}_{ses}_ctms_stim_settings.csv'))
    
    #%% Iterate each data collection block (Left/Right, 30/60/120us pulse width)
    #---------------------------------------------------------------------------
    for setting in stimSettings:
        
        # If data for this combination of side and pulse width is found, proceed
        side = setting['side'].lower()
        pw = setting['pulse width']
        matname = f'{subj}_{ses}_ctmsio_{side}_{pw}.mat'
        matpath = os.path.join(datapath, matname)
        
        if os.path.isfile(matpath):
            
            dataqcdir = os.path.join(datapath, 'dataQC')
            if not os.path.exists(dataqcdir):
                os.mkdir(os.path.join(dataqcdir))
            
            # Call function to unpack data from .mat file generated by Signal
            emgData, stateData, sample_interval = ctms_utils.unpackFrames(matpath)
            
            # Count number of consecutive occurrences of each state (i.e. index of pulse in each block of approx 10)
            indices = []
            counter = 0
            for k, g in groupby(stateData):
                for i, j in enumerate(g):
                    indices.append(i+1)
            
            stimSequence = []
            # Convert states to stim settings
            for state in stateData:
                try:
                    mt = int(setting[f'motor threshold'])
                    stim = int(setting[f'State {state}'])
                    stimSequence.append(stim/mt*100)
                except:
                    stimSequence.append(0)
                    
            #%% Iterate each frame(sweep) in the EMG data
            #------------------------------------------------------------------
            
            # Initialise empty variables
            wave_data = {}
            meps = []
            preconts = []
                
            # Convert MEP and pre-contraction time ranges to sample ranges
            sample_rate = int(1/sample_interval)
            mep_samples = (mep_time*sample_rate).astype(int)
            precon_samples = (precon_time*sample_rate).astype(int)
            
            for i, sweep in enumerate(emgData.T):
                
                # Select data range corresponding to pre-contraction and MEP
                precon_sweep = sweep[0][precon_samples[0]:precon_samples[1]]
                mep_sweep = sweep[0][mep_samples[0]:mep_samples[1]]
                
                                
                # Measure peak-to-peak amplitude in each region of interest
                preconts.append(precon_sweep.ptp())
                meps.append(mep_sweep.ptp())
                
                # Find EMG onsets using BioSPPy function
                onsets = find_onsets(signal=mep_sweep, sampling_rate=sample_rate, size=0.01)
                
                if plotEachSweep:
                    ctms_utils.plotEachSweep(mep_sweep, os.path.join(dataqcdir, f'{subj}_{ses}_{side}_{pw}_{i}.png'))
                    
            # Put states, stim settings, and MEP ptp amplitudes into a dataframe, 
            # group by frame state, calculate mean, count and standard deviation
            df = None
            df = pd.DataFrame()
            df['states'] = stateData
            df['stimIntensity'] = stimSequence
            df['meps'] = meps
            df['indices'] = indices
            df2 = df[df['states'] != 0]
            means = df2.groupby('stimIntensity').mean()
            counts = df2.groupby('stimIntensity').count()
            stdev = df2.groupby('stimIntensity').std()
            
            statemean = df2.groupby('states').mean()
            
            standardisedmep = []
            for i in range(len(df2)):
                standardisedmep.append(df2['meps'].iloc[i]/statemean['meps'].loc[df2['states'].iloc[i]])
            
            df2['standardisedmep'] = standardisedmep
            
            alldata = alldata.append(df2)
            
            df2 = df2[df2['indices'] > 1]
            
            #%% Fit sigmoid function using scipy.optimize.curve_fit
            #------------------------------------------------------------------
            popt, pcov = curve_fit(ctms_utils.sigmoid, df2['stimIntensity'], df2['meps'], method='dogbox', maxfev=10000, bounds=([2., 50., 10.], [15., 150., 1000.]))
            
            curvepars[f'{matname}'] = popt
            
            x = np.linspace(0, 200, 400)
            y = ctms_utils.sigmoid(x, *popt)
            
            #%% Write summary data for this block
            #------------------------------------------------------------------
            
            list_block_summary.append((subj, ses, side, pw, mt, popt))
            
#%% Call plotting functions
#------------------------------------------------------------------------------
            
            # Plot IO curve + scatter for each settings block       
            if plotEachBlock:
                ctms_utils.plotEachBlock(means, stdev, df2['stimIntensity'], df2['meps'], df2['indices'], x, y, os.path.join(plotdir, f'{subj}_ctmsio_{side}_{pw}.png'))

        
    #Plot all I/O curves per subject            
    if plotEachSubject:
        ctms_utils.groupIOplots(subj, ses, curvepars, os.path.join(plotdir, f'{subj}_{ses}.png'))

#%% plot of index within block (?pulse order effect)
#------------------------------------------------------------------------------
alldata2 = alldata[alldata['indices'] < 11]
sns.set_palette('muted')
ax4 = sns.boxenplot(x='indices', y='standardisedmep', data=alldata2)
ax4.set(xlim=(-1,10), ylim=(0.3,1.7), xlabel='nth pulse in block', ylabel='standardised MEP amplitude', title='Order effect within 10-pulse blocks')
fig4 = ax4.get_figure()
fig4.savefig(os.path.join(plotdir, 'ordereffect.png'), dpi=300)

#%% Make summary dataframe
#------------------------------------------------------------------------------

summarydf = pd.DataFrame(data=list_block_summary, columns=('subject', 'session', 'side', 'pulsewidth', 'rmt', 'curvepars'))

